\d .http

platformDelimeter:"\\"
rootDir:"c:\\q"

cannonicalizeFilename:{[aFilename]	//aFilename
	aFixedFilename:raze ssr[aFilename;"/";platformDelimeter];
	aFixedFilename:raze ssr[aFixedFilename;"\\";platformDelimeter];
	aFixedFilename}

oldzph:.z.ph

.z.ph:{ 	//.z.ph
		aQuery: x 0;
		theHeaders: x 1;
	
		//get rid of http encoding
		aQuery: .h.uh aQuery;

		if[0~count aQuery;:oldzph[x]];
		
		// split the file from the variables out of the query string
		aFilename:first "?" vs aQuery;
		aVariableString:last "?" vs aQuery;
		
		theVariables:parsePairs[aVariableString];

		//do something else here, all there are are variables
		if[0~count aFilename;:aVariableString];
		
		//-1 raze "vars: ", aVariableString;
                //if[count aVariableString;-1 raze"vars: ",aVariableString];

		//just serve the file
		//-1 raze "filename: ", aFilename;
		 if["svg/svg_chart_q" ~ aFilename;:.h.hy[`htm;q[theVariables]]];
		aContents:loadFile[aFilename];
		aType:`$last "." vs aFilename;
		//-1 raze "type: ", string aType;
		:.h.hy[aType;aContents]
	}

parsePairs:{[aQuery]	//parsePairs
	pairs:flip {"=" vs x} each "&" vs aQuery;
	pairs:(`$first pairs)!(last pairs);
	pairs}

loadFile:{[aFilename]	//loadFile
	if["favicon.ico"~aFilename;:""];
        aLongFilename:	cannonicalizeFilename[rootDir,platformDelimeter,aFilename];	//-1 raze "loading ",aLongFilename;
	aContent: "c"$read1 `$aLongFilename;
	aContent}

q:{[x]""}
